package com.ruoyi.bst.vipUser.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ruoyi.bst.vipUser.domain.VipUser;
import com.ruoyi.bst.vipUser.domain.VipUserQuery;
import com.ruoyi.bst.vipUser.domain.VipUserVO;

/**
 * 用户卡券Mapper接口
 *
 * @author ruoyi
 * @date 2025-05-26
 */
public interface VipUserMapper
{
    /**
     * 查询用户卡券
     *
     * @param id 用户卡券主键
     * @return 用户卡券
     */
    VipUserVO selectVipUserById(Long id);

    /**
     * 查询用户卡券列表
     *
     * @param query 用户卡券
     * @return 用户卡券集合
     */
    List<VipUserVO> selectVipUserList(@Param("query")VipUserQuery query);

    /**
     * 新增用户卡券
     *
     * @param vipUser 用户卡券
     * @return 结果
     */
    int insertVipUser(VipUser vipUser);

    /**
     * 批量新增用户卡券
     */
    int batchInsert(@Param("list") List<? extends VipUser> list);

    /**
     * 批量修改用户卡券
     */
    int batchUpdate(@Param("list") List<? extends VipUser> list);

    /**
     * 修改用户卡券
     *
     * @param vipUser 用户卡券
     * @return 结果
     */
    public int updateVipUser(@Param("data") VipUser vipUser);

    /**
     * 删除用户卡券
     *
     * @param id 用户卡券主键
     * @return 结果
     */
    int deleteVipUserById(Long id);

    /**
     * 批量删除用户卡券
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteVipUserByIds(Long[] ids);

    /**
     * 续费
     * @param id
     * @param days
     * @param total
     * @return
     */
    int renew(@Param("id") Long id, @Param("days") Long days, @Param("total") Integer total);

    /**
     * 查询ID列表
     * @param query
     * @return
     */
    List<Long> selectIdList(VipUserQuery query);

    /**
     * 逻辑删除
     * @param ids
     * @return
     */
    int logicDel(@Param("ids") List<Long> ids);

    /**
     * 恢复VIP优惠次数
     * @param vipUserId
     * @param count
     * @return
     */
    int recoverVipCount(@Param("vipUserId") Long vipUserId, @Param("count") int count);

    /**
     * 扣减VIP优惠次数
     * @param id
     * @param count
     * @return
     */
    int deductVipCount(@Param("id") Long id, @Param("count") int count);
}
